// timer.cpp
#include <stdlib.h>
#include <dos.h>
#include "timer.h"

#define TIMER_RATE		55
#ifdef __cplusplus
	 #define __CPPARGS ...
#else
	 #define __CPPARGS
#endif

static void _interrupt _far (*old_timer)(__CPPARGS);
static unsigned long clock;

void _interrupt _far new_timer(__CPPARGS)
{
 clock+=TIMER_RATE;
 old_timer();
}

unsigned long timer_Init()
{
 clock=0;
 old_timer=_dos_getvect(0x1C);
 _dos_setvect(0x1C,new_timer);
 return TIMER_OK;
}

void timer_Destroy()
{
 _dos_setvect(0x1C,old_timer);
}

inline unsigned long timer_Clock()
{
 return clock;
}

void timer_Wait(unsigned long wait)
{
 register unsigned long lastclock=timer_Clock();
 while (timer_Interval(lastclock)<wait);
}

