// cfifo.h

#ifndef _CFIFO_
#define _CFIFO_

//---------------------------------------------------------------------------

class CFifo
{
 private:

  unsigned short 	bytes;
  unsigned short 	last;
  unsigned short 	first;
  unsigned short 	size;
  unsigned char* 	data;

 public:
						CFifo(int size);
						~CFifo();
  void 				Reset();
  unsigned short 	Write(unsigned char *data,unsigned short size);
  unsigned short 	Read(unsigned char *data,unsigned short size);
  unsigned short 	GetSize();
  unsigned short 	GetFree();
};

//---------------------------------------------------------------------------

inline void CFifo::Reset()
{
 bytes=last=first=0;
}

//---------------------------------------------------------------------------

inline unsigned short CFifo::GetSize()
{
 return bytes;
}

//---------------------------------------------------------------------------

inline unsigned short CFifo::GetFree()
{
 return (unsigned short)(size-bytes);
}

//---------------------------------------------------------------------------

#endif
